
;;; macro table handling

(define *macros* (make-hash-table eq?))

;; formal parameters

(define (maybe-substitute-with-index sym ls)
  (cond ((memq sym ls)
	 => (lambda (match) (- (length ls) (length match))))
	(else sym)))

(define (substitute-positional binds body)
  (cond ((pair? body) (cons (substitute-positional binds (car body))
			    (substitute-positional binds (cdr body))))
	((symbol? body) (maybe-substitute-with-index body binds))
	(else body)))

;; adding macros

(define (add-macro name formals body)
  (let* ((body (substitute-positional formals body))
	 (closure `(clos ,(length formals) () ,name ,body)))
    (hash-table-set! *macros* name closure)))

(define (add-stream name) 'not-implemented-yet)

