
(load "stream.ss")
(load "deque.ss")
(load "mparser.ss")
(load "hash.ss")
(load "b5-expr.ss")
(load "b5-input.ss")
(load "b5-output.ss")
(load "b5-macros.ss")
(load "b5-syntax.ss")
(load "b5-eval.ss")

(define *quiet* #f)

(define (process-argument arg)
  (case (string-ref arg 1)
    ((#\q) (set! *quiet* #t))
    ((#\l) (set! *print-literal-markers* #t))
    ((#\p) (set! *expand-parenthese-contents* #f))
    (else (error "Unknown argument: " arg))))

(define (main args)
  (let ((stdin-is-data #t))
    (for-each
      (lambda (a)
	(cond ((equal? a "-") (set! stdin-is-data #f) (add-code-file a))
	      ((equal? (string-ref a 0) #\-) (process-argument a))
	      (else (add-code-file a))))
      (cdr args))
    (if stdin-is-data (add-data-file "-"))
    (let ((result (expr-eval (read-b5-input))))
      (if (not *quiet*) (expr-print result)))))

