
(define *print-literal-markers* #f)

(define (expr-print data)
  (case (expr-type data)
    ((paren) (display #\() (expr-print (cdr data)) (display #\)))
    ((seq res pacl) (for-each expr-print (cdr data)))
    ((lit nlit) (expr-literal-print data))
    ((clos) (expr-closure-print data))
    ((ident empty) (display data))
    (else (error "expr-print: unknown expression: " data))))

(define (expr-literal-print data)
  (if (and *print-literal-markers* (expr-type? data 'lit))
    (begin (display "<<<")
	   (display (expr-literal-content data))
	   (display ">>>"))
    (display (expr-literal-content data))))

(define (expr-closure-print clos)
  (if (expr-closure-name clos) (display (expr-closure-name clos)))
  (for-each expr-print (reverse (expr-closure-arguments clos))))

(define (add-output-stream foo) 'not-implemented-yet)

