
(define (make-deque) (cons '() '()))

(define (deque-empty? dq) (null? (cdr dq)))

(define (deque-enqueue! dq elem)
  (if (deque-empty? dq) (deque-set! dq (list elem))
    (begin (set-cdr! (cdr dq) (list elem))
	   (set-cdr! dq (cddr dq)))))

(define (deque-push! dq elem)
  (if (deque-empty? dq) (deque-set! dq (list elem))
    (set-car! dq (cons elem (car dq)))))

(define (deque-pop! dq)
  (if (deque-empty? dq) (error "deque-pop!: queue empty")
    (let ((retval (caar dq)))
      (if (null? (cdar dq))
	(deque-set! dq '())
	(set-car! dq (cdar dq)))
      retval)))

; only works if contents is empty or singleton
(define (deque-set! dq contents)
  (set-car! dq contents)
  (set-cdr! dq contents))

(define (deque-filter! dq pred)
  (let ((ls (car dq)))
    (deque-set! dq '())
    (let loop ((ls ls))
      (if (null? ls) #t
	(begin
	 (if (pred (car ls)) (deque-enqueue! dq (car ls)))
	 (loop (cdr ls)))))))

(define deque->list car)

